#!/usr/bin/env python

func_arg_list = [[2, 0], [1, 0], [3, 1], [1, 1], [4, 0], [0, 1], [0, 1], [0, 1], [3, 0], [3, 0], [2, 0], [1, 0], [1, 0], [4, 0], [3, 0], [5, 0], [2, 0], [2, 0], [2, 0], [3, 0], [0, 0]]

cvt_dict = {
    'evheight_lu' : 0,   #  -417    ;eng vheight p,q
    'vbase' : 1,   #  0            ;all vbase
    'tvheight_num' : 2,   #  908    ;thai vheight number
    'evheight' : 3,   #  1062       ;eng vheight normal
    'tvheight' : 4,   #  1140       ;thai vheight normal
    'ecvheight' : 5,   #  1450      ;eng capital vheight normal
    'estemtc' : 6,   #  160         ;eng stem thick - curve
    'cvt_7' : 7,   #  112
    'cvt_8' : 8,   #  124
    'headstem' : 9,   #  130        ;head stem width/thick
    'estemt' : 10,   #  148          ;eng stem thick
    'cvt_11' : 11,   #  164
    'cvt_12' : 12,   #  168
    'ecstemt' : 13,   #  173        ;eng cap stem thick
    'ecstemw' : 14,   #  180        ;eng cap stem width
    'headstem_thick' : 15,   #  160 ;head stem - thick
    'estemw' : 16,   #  180         ;eng stem width
    'cvt_17' : 17,   #  175
    'cvt_18' : 18,   #  191
    'cvt_19' : 19,   #  193
    'cvt_20' : 20,   #  201
    'cvt_21' : 21,   #  197
    'cvt_22' : 22,   #  138
    'cvt_23' : 23,   #  144
    'cvt_24' : 24,   #  178
    'cvt_25' : 25,   #  152
    'cvt_26' : 26,   #  156
    'cvt_27' : 27,   #  154
    'cvt_28' : 28,   #  103
    'cvt_29' : 29,   #  142
    'cvt_30' : 30,   #  122
    'cvt_31' : 31,   #  24
    'cvt_32' : 32,   #  932
    'cvt_33' : 33,   #  1088
    'cvt_34' : 34,   #  1166
    'cvt_35' : 35,   #  1482
    'cvt_36' : 36,   #  300
    'cvt_37' : 37,   #  430
    'cvt_38' : 38,   #  1477
    'cvt_39' : 39,   #  334
    'cvt_40' : 40,   #  0
    'cvt_41' : 41,   #  101
    }

pseudo_fpgm = """
                           #--- PUSHB_1   0         ;PUSH Bytes
FDEF            0          ;Function DEFinition
                           #--- PUSHB_1   0         ;PUSH Bytes
SZP0            0          ;Set Zone Pointer 0
MPPEM                      ;Measure Pixels Per EM
                           #--- PUSHB_1   42        ;PUSH Bytes
LT              42 &_MPPEM_1 ; Less Than
IF              &_LT_1     ;   IF test
                           #--- PUSHB_1   74        ;PUSH Bytes
SROUND          74         ;Super ROUND
EIF                        ;    End IF
                           #--- PUSHB_1   0         ;PUSH Bytes
SWAP            0 &_arg_1  ;SWAP the top two elements on the stack
MIAP[rnd]       &_SWAP_1 &_SWAP_2 ;Move Indirect Absolute Point
RTG                        ;Round To Grid
                           #--- PUSHB_1   6         ;PUSH Bytes
CALL            6          ;CALL function
IF              &_f6_retval_1 ;   IF test
RTDG                       ;Round To Double Grid
EIF                        ;    End IF
MPPEM                      ;Measure Pixels Per EM
                           #--- PUSHB_1   42        ;PUSH Bytes
LT              42 &_MPPEM_1 ; Less Than
IF              &_LT_1     ;   IF test
RDTG                       ;Round Down To Grid
EIF                        ;    End IF
DUP             &_arg_2    ;DUPlicate top stack element
MDRP[rp0,rnd,grey] &_DUP_1    ;Move Direct Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SZP0            1          ;Set Zone Pointer 0
MDAP[no-rnd]    &_DUP_2    ;Move Direct Absolute Point
RTG                        ;Round To Grid
ENDF                       ;END Function definition
#ARG_COUNT=2:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   1         ;PUSH Bytes
FDEF            1          ;Function DEFinition
DUP             &_arg_1    ;DUPlicate top stack element
MDRP[rp0,min,white] &_DUP_1    ;Move Direct Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
CALL            12 &_DUP_2 ;CALL function
ENDF                       ;END Function definition
#ARG_COUNT=1:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   2         ;PUSH Bytes
FDEF            2          ;Function DEFinition
MPPEM                      ;Measure Pixels Per EM
GT              &_MPPEM_1 &_arg_1 ;Greater Than
IF              &_GT_1     ;   IF test
RCVT            &_arg_2    ;Read Control Value Table entry
SWAP            &_RCVT_1 &_arg_3 ;SWAP the top two elements on the stack
EIF                        ;    End IF
POP             &_SWAP_1   ;POP top stack element
ENDF                       ;END Function definition
#ARG_COUNT=3:
#RET_COUNT=1: &_SWAP_2
#------------------
#STACK_REMAIN=RETURN : &_f2_retval_1
#------------------

                           #--- PUSHB_1   3         ;PUSH Bytes
FDEF            3          ;Function DEFinition
ROUND[Black]    &_arg_1    ;ROUND value
RTG                        ;Round To Grid
DUP             &_ROUND_1  ;DUPlicate top stack element
                           #--- PUSHB_1   64        ;PUSH Bytes
LT              64 &_DUP_1 ; Less Than
IF              &_LT_1     ;   IF test
POP             &_DUP_2    ;POP top stack element
                           #--- PUSHB_1   64        ;PUSH Bytes
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=1:
#RET_COUNT=1: 64
#------------------
#STACK_REMAIN=RETURN : &_f3_retval_1
#------------------

                           #--- PUSHB_1   4         ;PUSH Bytes
FDEF            4          ;Function DEFinition
                           #--- PUSHB_1   6         ;PUSH Bytes
CALL            6          ;CALL function
IF              &_f6_retval_1 ;   IF test
POP             &_arg_1    ;POP top stack element
SWAP            &_arg_2 &_arg_3 ;SWAP the top two elements on the stack
POP             &_SWAP_1   ;POP top stack element
ROFF                       ; Round OFF
IF              &_SWAP_2   ;   IF test
MDRP[rp0,min,rnd,black] &_arg_4    ;Move Direct Relative Point
ELSE                       ;ELSE clause
MDRP[min,rnd,black] &_arg_4    ;Move Direct Relative Point
EIF                        ;    End IF
ELSE                       ;ELSE clause
MPPEM                      ;Measure Pixels Per EM
GT              &_MPPEM_1 &_arg_1 ;Greater Than
IF              &_GT_1     ;   IF test
IF              &_arg_2    ;   IF test
MIRP[rp0,min,rnd,black] &_arg_3 &_arg_4 ;Move Indirect Relative Point
ELSE                       ;ELSE clause
MIRP[min,rnd,black] &_arg_3 &_arg_4 ;Move Indirect Relative Point
EIF                        ;    End IF
ELSE                       ;ELSE clause
SWAP            &_arg_2 &_arg_3 ;SWAP the top two elements on the stack
POP             &_SWAP_1   ;POP top stack element
                           #--- PUSHB_1   5         ;PUSH Bytes
CALL            5          ;CALL function
IF              &_f5_retval_1 ;   IF test
                           #--- PUSHB_1   70        ;PUSH Bytes
SROUND          70         ;Super ROUND
EIF                        ;    End IF
IF              &_SWAP_2   ;   IF test
MDRP[rp0,min,rnd,black] &_arg_4    ;Move Direct Relative Point
ELSE                       ;ELSE clause
MDRP[min,rnd,black] &_arg_4    ;Move Direct Relative Point
EIF                        ;    End IF
EIF                        ;    End IF
EIF                        ;    End IF
RTG                        ;Round To Grid
ENDF                       ;END Function definition
#ARG_COUNT=4:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   5         ;PUSH Bytes
FDEF            5          ;Function DEFinition
GFV                        ;Get Freedom Vector
NOT             &_GFV_1    ;logical NOT
AND             &_NOT_1 &_GFV_2 ;logical AND
ENDF                       ;END Function definition
#ARG_COUNT=0:
#RET_COUNT=1: &_AND_1
#------------------
#STACK_REMAIN=RETURN : &_f5_retval_1
#------------------

                           #--- PUSHB_1   6         ;PUSH Bytes
FDEF            6          ;Function DEFinition
                           #--- PUSHB_2   34 1      ;PUSH Bytes
GETINFO         1          ;GET INFOrmation
LT              &_GETINFO_1 34 ; Less Than
IF              &_LT_1     ;   IF test
                           #--- PUSHB_1   32        ;PUSH Bytes
GETINFO         32         ;GET INFOrmation
NOT             &_GETINFO_1 ;logical NOT
NOT             &_NOT_1    ;logical NOT
ELSE                       ;ELSE clause
                           #--- PUSHB_1   0         ;PUSH Bytes
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=0:
#RET_COUNT=1: &_NOT_1
#------------------
#STACK_REMAIN=RETURN : &_f6_retval_1
#------------------

                           #--- PUSHB_1   7         ;PUSH Bytes
FDEF            7          ;Function DEFinition
                           #--- PUSHB_2   36 1      ;PUSH Bytes
GETINFO         1          ;GET INFOrmation
LT              &_GETINFO_1 36 ; Less Than
IF              &_LT_1     ;   IF test
                           #--- PUSHB_1   64        ;PUSH Bytes
GETINFO         64         ;GET INFOrmation
NOT             &_GETINFO_1 ;logical NOT
NOT             &_NOT_1    ;logical NOT
ELSE                       ;ELSE clause
                           #--- PUSHB_1   0         ;PUSH Bytes
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=0:
#RET_COUNT=1: &_NOT_1
#------------------
#STACK_REMAIN=RETURN : &_f7_retval_1
#------------------

                           #--- PUSHB_1   8         ;PUSH Bytes
FDEF            8          ;Function DEFinition
SRP2            &_arg_1    ;Set Reference Point 2
SRP1            &_arg_2    ;Set Reference Point 1
DUP             &_arg_3    ;DUPlicate top stack element
IP              &_DUP_1    ;Interpolate Point
MDAP[rnd]       &_DUP_2    ;Move Direct Absolute Point
ENDF                       ;END Function definition
#ARG_COUNT=3:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   9         ;PUSH Bytes
FDEF            9          ;Function DEFinition
DUP             &_arg_1    ;DUPlicate top stack element
RDTG                       ;Round Down To Grid
                           #--- PUSHB_1   6         ;PUSH Bytes
CALL            6          ;CALL function
IF              &_f6_retval_1 ;   IF test
MDRP[rnd,grey]  &_DUP_1    ;Move Direct Relative Point
ELSE                       ;ELSE clause
MDRP[min,rnd,black] &_DUP_2    ;Move Direct Relative Point
EIF                        ;    End IF
DUP             &_DUP_2    ;DUPlicate top stack element
                           #--- PUSHB_1   3         ;PUSH Bytes
CINDEX          3          ;Copy the INDEXed element to the top of the stack
MD[grid]        &_CINDEX_1 &_DUP_1 ;Measure Distance
SWAP            &_MD_1 &_DUP_2 ;SWAP the top two elements on the stack
DUP             &_SWAP_1   ;DUPlicate top stack element
                           #--- PUSHB_1   4         ;PUSH Bytes
MINDEX          4          ;Move the INDEXed element to the top of the stack
MD[orig]        &_DUP_1 &_DUP_2 ;Measure Distance
                           #--- PUSHB_1   0         ;PUSH Bytes
LT              0 &_MD_1   ; Less Than
IF              &_LT_1     ;   IF test
ROLL            &_SWAP_2 &_arg_2 &_arg_3 ;ROLL the top three stack elements
NEG             &_ROLL_1   ;    NEGate
ROLL            &_NEG_1 &_ROLL_2 &_ROLL_3 ;ROLL the top three stack elements
SUB             &_ROLL_1 &_ROLL_2 ;  SUBtract
DUP             &_SUB_1    ;DUPlicate top stack element
                           #--- PUSHB_1   0         ;PUSH Bytes
LT              0 &_DUP_1  ; Less Than
IF              &_LT_1     ;   IF test
SHPIX           &_DUP_2 &_ROLL_3 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg_4    ;POP top stack element
POP             &_arg_5    ;POP top stack element
EIF                        ;    End IF
ELSE                       ;ELSE clause
ROLL            &_arg_2 &_arg_3 &_arg_4 ;ROLL the top three stack elements
ROLL            &_ROLL_1 &_ROLL_2 &_ROLL_3 ;ROLL the top three stack elements
SUB             &_ROLL_1 &_ROLL_2 ;  SUBtract
DUP             &_SUB_1    ;DUPlicate top stack element
                           #--- PUSHB_1   0         ;PUSH Bytes
GT              0 &_DUP_1  ;Greater Than
IF              &_GT_1     ;   IF test
SHPIX           &_DUP_2 &_ROLL_3 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg_5    ;POP top stack element
POP             &_arg_6    ;POP top stack element
EIF                        ;    End IF
EIF                        ;    End IF
RTG                        ;Round To Grid
ENDF                       ;END Function definition
#ARG_COUNT=3:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   10        ;PUSH Bytes
FDEF            10         ;Function DEFinition
                           #--- PUSHB_1   6         ;PUSH Bytes
CALL            6          ;CALL function
IF              &_f6_retval_1 ;   IF test
POP             &_arg_1    ;POP top stack element
SRP0            &_arg_2    ;Set Reference Point 0
ELSE                       ;ELSE clause
SRP0            &_arg_1    ;Set Reference Point 0
POP             &_arg_2    ;POP top stack element
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=2:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   11        ;PUSH Bytes
FDEF            11         ;Function DEFinition
DUP             &_arg_1    ;DUPlicate top stack element
MDRP[rp0,white] &_DUP_1    ;Move Direct Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
CALL            12 &_DUP_2 ;CALL function
ENDF                       ;END Function definition
#ARG_COUNT=1:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   12        ;PUSH Bytes
FDEF            12         ;Function DEFinition
DUP             &_arg_1    ;DUPlicate top stack element
MDAP[rnd]       &_DUP_1    ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
CALL            7          ;CALL function
NOT             &_f7_retval_1 ;logical NOT
IF              &_NOT_1    ;   IF test
DUP             &_DUP_2    ;DUPlicate top stack element
DUP             &_DUP_1    ;DUPlicate top stack element
GC[orig]        &_DUP_1    ;Get Coordinate projected onto the projection vector
SWAP            &_GC_1 &_DUP_2 ;SWAP the top two elements on the stack
GC[cur]         &_SWAP_1   ;Get Coordinate projected onto the projection vector
SUB             &_GC_1 &_SWAP_2 ;  SUBtract
ROUND[White]    &_SUB_1    ;ROUND value
DUP             &_ROUND_1  ;DUPlicate top stack element
IF              &_DUP_1    ;   IF test
DUP             &_DUP_2    ;DUPlicate top stack element
ABS             &_DUP_1    ;ABSolute value
DIV             &_ABS_1 &_DUP_2 ;    DIVide
SHPIX           &_DIV_1 &_DUP_2 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg_2    ;POP top stack element
POP             &_arg_3    ;POP top stack element
EIF                        ;    End IF
ELSE                       ;ELSE clause
POP             &_arg_2    ;POP top stack element
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=1:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   13        ;PUSH Bytes
FDEF            13         ;Function DEFinition
SRP2            &_arg_1    ;Set Reference Point 2
SRP1            &_arg_2    ;Set Reference Point 1
DUP             &_arg_3    ;DUPlicate top stack element
DUP             &_DUP_1    ;DUPlicate top stack element
IP              &_DUP_1    ;Interpolate Point
MDAP[rnd]       &_DUP_2    ;Move Direct Absolute Point
DUP             &_DUP_2    ;DUPlicate top stack element
ROLL            &_DUP_1 &_DUP_2 &_arg_4 ;ROLL the top three stack elements
DUP             &_ROLL_1   ;DUPlicate top stack element
GC[orig]        &_DUP_1    ;Get Coordinate projected onto the projection vector
ROLL            &_GC_1 &_DUP_2 &_ROLL_2 ;ROLL the top three stack elements
GC[cur]         &_ROLL_1   ;Get Coordinate projected onto the projection vector
SUB             &_GC_1 &_ROLL_2 ;  SUBtract
SWAP            &_SUB_1 &_ROLL_3 ;SWAP the top two elements on the stack
ROLL            &_SWAP_1 &_SWAP_2 &_ROLL_3 ;ROLL the top three stack elements
DUP             &_ROLL_1   ;DUPlicate top stack element
ROLL            &_DUP_1 &_DUP_2 &_ROLL_2 ;ROLL the top three stack elements
SWAP            &_ROLL_1 &_ROLL_2 ;SWAP the top two elements on the stack
MD[orig]        &_SWAP_1 &_SWAP_2 ;Measure Distance
                           #--- PUSHB_1   0         ;PUSH Bytes
LT              0 &_MD_1   ; Less Than
IF              &_LT_1     ;   IF test
SWAP            &_ROLL_3 &_ROLL_3 ;SWAP the top two elements on the stack
                           #--- PUSHB_1   0         ;PUSH Bytes
GT              0 &_SWAP_1 ;Greater Than
IF              &_GT_1     ;   IF test
                           #--- PUSHB_1   64        ;PUSH Bytes
SHPIX           64 &_SWAP_2 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg_5    ;POP top stack element
EIF                        ;    End IF
ELSE                       ;ELSE clause
SWAP            &_arg_5 &_arg_6 ;SWAP the top two elements on the stack
                           #--- PUSHB_1   0         ;PUSH Bytes
LT              0 &_SWAP_1 ; Less Than
IF              &_LT_1     ;   IF test
                           #--- PUSHB_1   64        ;PUSH Bytes
NEG             64         ;    NEGate
SHPIX           &_NEG_1 &_SWAP_2 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg_7    ;POP top stack element
EIF                        ;    End IF
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=4:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   14        ;PUSH Bytes
FDEF            14         ;Function DEFinition
                           #--- PUSHB_1   6         ;PUSH Bytes
CALL            6          ;CALL function
IF              &_f6_retval_1 ;   IF test
RTDG                       ;Round To Double Grid
MDRP[rp0,rnd,white] &_arg_1    ;Move Direct Relative Point
RTG                        ;Round To Grid
POP             &_arg_2    ;POP top stack element
POP             &_arg_3    ;POP top stack element
ELSE                       ;ELSE clause
DUP             &_arg_1    ;DUPlicate top stack element
MDRP[rp0,rnd,white] &_DUP_1    ;Move Direct Relative Point
ROLL            &_DUP_2 &_arg_2 &_arg_3 ;ROLL the top three stack elements
MPPEM                      ;Measure Pixels Per EM
GT              &_MPPEM_1 &_ROLL_1 ;Greater Than
IF              &_GT_1     ;   IF test
DUP             &_ROLL_2   ;DUPlicate top stack element
ROLL            &_DUP_1 &_DUP_2 &_ROLL_3 ;ROLL the top three stack elements
SWAP            &_ROLL_1 &_ROLL_2 ;SWAP the top two elements on the stack
MD[grid]        &_SWAP_1 &_SWAP_2 ;Measure Distance
DUP             &_MD_1     ;DUPlicate top stack element
                           #--- PUSHB_1   0         ;PUSH Bytes
NEQ             0 &_DUP_1  ; Not EQual
IF              &_NEQ_1    ;   IF test
SHPIX           &_DUP_2 &_ROLL_3 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg_4    ;POP top stack element
POP             &_arg_5    ;POP top stack element
EIF                        ;    End IF
ELSE                       ;ELSE clause
POP             &_arg_4    ;POP top stack element
POP             &_arg_5    ;POP top stack element
EIF                        ;    End IF
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=3:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   15        ;PUSH Bytes
FDEF            15         ;Function DEFinition
SWAP            &_arg_1 &_arg_2 ;SWAP the top two elements on the stack
DUP             &_SWAP_1   ;DUPlicate top stack element
MDRP[rp0,rnd,white] &_DUP_1    ;Move Direct Relative Point
DUP             &_DUP_2    ;DUPlicate top stack element
MDAP[rnd]       &_DUP_1    ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
CALL            7          ;CALL function
NOT             &_f7_retval_1 ;logical NOT
IF              &_NOT_1    ;   IF test
SWAP            &_DUP_2 &_SWAP_2 ;SWAP the top two elements on the stack
DUP             &_SWAP_1   ;DUPlicate top stack element
IF              &_DUP_1    ;   IF test
MPPEM                      ;Measure Pixels Per EM
GTEQ            &_MPPEM_1 &_DUP_2 ;Greater Than or EQual
ELSE                       ;ELSE clause
POP             &_GTEQ_1   ;POP top stack element
                           #--- PUSHB_1   1         ;PUSH Bytes
EIF                        ;    End IF
IF              &_GTEQ_1   ;   IF test
ROLL            &_SWAP_2 &_arg_3 &_arg_4 ;ROLL the top three stack elements
                           #--- PUSHB_1   4         ;PUSH Bytes
MINDEX          4          ;Move the INDEXed element to the top of the stack
MD[grid]        &_ROLL_1 &_ROLL_2 ;Measure Distance
SWAP            &_MD_1 &_ROLL_3 ;SWAP the top two elements on the stack
ROLL            &_SWAP_1 &_SWAP_2 &_arg_5 ;ROLL the top three stack elements
SWAP            &_ROLL_1 &_ROLL_2 ;SWAP the top two elements on the stack
DUP             &_SWAP_1   ;DUPlicate top stack element
ROLL            &_DUP_1 &_DUP_2 &_SWAP_2 ;ROLL the top three stack elements
MD[grid]        &_ROLL_1 &_ROLL_2 ;Measure Distance
ROLL            &_MD_1 &_ROLL_3 &_ROLL_3 ;ROLL the top three stack elements
SWAP            &_ROLL_1 &_ROLL_2 ;SWAP the top two elements on the stack
SUB             &_SWAP_1 &_SWAP_2 ;  SUBtract
SHPIX           &_SUB_1 &_ROLL_3 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg_3    ;POP top stack element
POP             &_arg_4    ;POP top stack element
POP             &_arg_5    ;POP top stack element
POP             &_arg_6    ;POP top stack element
EIF                        ;    End IF
ELSE                       ;ELSE clause
POP             1          ;POP top stack element
POP             &_SWAP_2   ;POP top stack element
POP             &_arg_3    ;POP top stack element
POP             &_arg_4    ;POP top stack element
POP             &_arg_5    ;POP top stack element
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=5:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   16        ;PUSH Bytes
FDEF            16         ;Function DEFinition
DUP             &_arg_1    ;DUPlicate top stack element
MDRP[rp0,min,white] &_DUP_1    ;Move Direct Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
CALL            18 &_DUP_2 &_arg_2 ;CALL function
ENDF                       ;END Function definition
#ARG_COUNT=2:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   17        ;PUSH Bytes
FDEF            17         ;Function DEFinition
DUP             &_arg_1    ;DUPlicate top stack element
MDRP[rp0,white] &_DUP_1    ;Move Direct Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
CALL            18 &_DUP_2 &_arg_2 ;CALL function
ENDF                       ;END Function definition
#ARG_COUNT=2:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   18        ;PUSH Bytes
FDEF            18         ;Function DEFinition
DUP             &_arg_1    ;DUPlicate top stack element
MDAP[rnd]       &_DUP_1    ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
CALL            7          ;CALL function
NOT             &_f7_retval_1 ;logical NOT
IF              &_NOT_1    ;   IF test
DUP             &_DUP_2    ;DUPlicate top stack element
DUP             &_DUP_1    ;DUPlicate top stack element
GC[orig]        &_DUP_1    ;Get Coordinate projected onto the projection vector
SWAP            &_GC_1 &_DUP_2 ;SWAP the top two elements on the stack
GC[cur]         &_SWAP_1   ;Get Coordinate projected onto the projection vector
SUB             &_GC_1 &_SWAP_2 ;  SUBtract
ROUND[White]    &_SUB_1    ;ROUND value
ROLL            &_ROUND_1 &_DUP_2 &_arg_2 ;ROLL the top three stack elements
DUP             &_ROLL_1   ;DUPlicate top stack element
GC[orig]        &_DUP_1    ;Get Coordinate projected onto the projection vector
SWAP            &_GC_1 &_DUP_2 ;SWAP the top two elements on the stack
GC[cur]         &_SWAP_1   ;Get Coordinate projected onto the projection vector
SWAP            &_GC_1 &_SWAP_2 ;SWAP the top two elements on the stack
SUB             &_SWAP_1 &_SWAP_2 ;  SUBtract
ROUND[White]    &_SUB_1    ;ROUND value
ADD             &_ROUND_1 &_ROLL_2 ;       ADD
DUP             &_ADD_1    ;DUPlicate top stack element
IF              &_DUP_1    ;   IF test
DUP             &_DUP_2    ;DUPlicate top stack element
ABS             &_DUP_1    ;ABSolute value
DIV             &_ABS_1 &_DUP_2 ;    DIVide
SHPIX           &_DIV_1 &_ROLL_3 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg_3    ;POP top stack element
POP             &_arg_4    ;POP top stack element
EIF                        ;    End IF
ELSE                       ;ELSE clause
POP             &_arg_2    ;POP top stack element
POP             &_arg_3    ;POP top stack element
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=2:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   19        ;PUSH Bytes
FDEF            19         ;Function DEFinition
DUP             &_arg_1    ;DUPlicate top stack element
ROLL            &_DUP_1 &_DUP_2 &_arg_2 ;ROLL the top three stack elements
DUP             &_ROLL_1   ;DUPlicate top stack element
ROLL            &_DUP_1 &_DUP_2 &_ROLL_2 ;ROLL the top three stack elements
SDPVTL[orthog]  &_ROLL_1 &_ROLL_2 ;Set Dual Projection Vector To Line
DUP             &_ROLL_3   ;DUPlicate top stack element
                           #--- PUSHB_1   3         ;PUSH Bytes
CINDEX          3          ;Copy the INDEXed element to the top of the stack
MD[orig]        &_CINDEX_1 &_DUP_1 ;Measure Distance
ABS             &_MD_1     ;ABSolute value
SWAP            &_ABS_1 &_DUP_2 ;SWAP the top two elements on the stack
ROLL            &_SWAP_1 &_SWAP_2 &_ROLL_3 ;ROLL the top three stack elements
SPVTL[orthog]   &_ROLL_1 &_ROLL_2 ;Set Projection Vector To Line
                           #--- PUSHB_1   32        ;PUSH Bytes
LT              32 &_ROLL_3 ; Less Than
IF              &_LT_1     ;   IF test
ALIGNRP         &_arg_3    ;ALIGN to Reference Point
ELSE                       ;ELSE clause
MDRP[grey]      &_arg_3    ;Move Direct Relative Point
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=3:
#RET_COUNT=0: 
#------------------

ENDF                       ;END Function definition
#ARG_COUNT=0:
#RET_COUNT=0: 
#------------------
"""

